package <%=domain_name%>.biz.service.impl;

import <%=domain%>.common.exception.BusinessException;
import <%=domain%>.common.utils.FilterUtils;
import <%=domain%>.common.utils.MongoEntityUtils;
import <%=domain%>.common.utils.PageableUtils;
import <%=domain%>.common.utils.SearchUtils;
import <%=domain_name%>.biz.dto.<%=module%>DTO;
import <%=domain_name%>.biz.dto.<%=module%>SearchDTO;
import <%=domain_name%>.biz.entity.<%=module%>Entity;
import <%=domain_name%>.biz.mapper.<%=module%>Mapper;
import <%=domain_name%>.biz.service.<%=module%>Service;
import <%=domain_name%>.web.vo.request.<%=module%>PageableRequest;
import lombok.RequiredArgsConstructor;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
@RequiredArgsConstructor
public class <%=module%>ServiceImpl implements <%=module%>Service {
     private final MongoTemplate template;

     @Override
     public <%=module%>DTO create(<%=module%>DTO dto) {
          <%=module%>Entity entity = new <%=module%>Entity();
          <%=module%>Mapper.INSTANCE.dtoToEntity(dto, entity);
          template.save(entity);
          <%=module%>Mapper.INSTANCE.entityToDto(entity, dto);
          return dto;
     }

     @Override
     public <%=module%>DTO update(String id, <%=module%>DTO <%=module%>DTO) throws BusinessException {
          <%=module%>Entity entity = MongoEntityUtils.findEntityById(template, <%=module%>Entity.class, id);
          <%=module%>Mapper.INSTANCE.dtoToEntity(<%=module%>DTO, entity);
          template.save(entity);
          <%=module%>Mapper.INSTANCE.entityToDto(entity, <%=module%>DTO);
          return <%=module%>DTO;
     }

     @Override
     public void delete(String id) throws BusinessException {
          <%=module%>Entity entity = MongoEntityUtils.findEntityById(template, <%=module%>Entity.class, id);
          template.remove(entity);
     }

     @Override
     public Page<<%=module%>DTO> findAll(<%=module%>DTO dto, <%=module%>PageableRequest request) throws BusinessException {
          List<<%=module%>DTO> <%=module%>List = new ArrayList<>();
          Criteria criteria = new Criteria();

          //search keyword
          if(ObjectUtils.isNotEmpty(request.getKeywords()))
               SearchUtils.generate(criteria, <%=module%>SearchDTO.class, request.getKeywords());
          if(ObjectUtils.isNotEmpty(request.getFilter()))
               FilterUtils.generate(criteria, <%=module%>SearchDTO.class, request.getFilter());

          Page<<%=module%>Entity> page =  PageableUtils.generate(template, <%=module%>Entity.class, criteria, request);
          List<<%=module%>Entity> items = page.getContent();
          long record = page.getTotalElements();
          if(ObjectUtils.isNotEmpty(items) && record > 0)
          {
               <%=module%>Mapper.INSTANCE.listEntityToDto(items, <%=module%>List);
          }

          return new PageImpl<>(<%=module%>List, page.getPageable(), record);
     }

     @Override
     public <%=module%>DTO findOne(String id) throws BusinessException {
          <%=module%>DTO <%=module%>DTO = new <%=module%>DTO();
          <%=module%>Entity entity = MongoEntityUtils.findEntityById(template, <%=module%>Entity.class, id);
          <%=module%>Mapper.INSTANCE.entityToDto(entity, <%=module%>DTO);
          return <%=module%>DTO;
     }
}
