package <%=domain_name%>.web.controller;

import <%=domain%>.common.controller.AbstractController;
import <%=domain%>.common.controller.ResponseBuilderMessage;
import <%=domain%>.common.controller.ResponseMessage;
import <%=domain%>.common.response.PageableResponse;
import <%=domain_name%>.biz.dto.<%=module%>DTO;
import <%=domain_name%>.biz.mapper.<%=module%>Mapper;
import <%=domain_name%>.biz.service.<%=module%>Service;
import <%=domain_name%>.web.vo.request.<%=module%>CreatedRequest;
import <%=domain_name%>.web.vo.request.<%=module%>PageableRequest;
import <%=domain_name%>.web.vo.request.<%=module%>UpdatedRequest;
import <%=domain_name%>.web.vo.response.<%=module%>ItemResponse;
import <%=domain_name%>.web.vo.response.<%=module%>Response;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.RequiredArgsConstructor;
import lombok.SneakyThrows;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@Tag(name = "<%=module_lower_case%>")
@RestController
@RequestMapping("api/<%=module_lower_case%>s")
@RequiredArgsConstructor
public class <%=module%>Controller implements AbstractController<<%=module%>ItemResponse, <%=module%>Response, <%=module%>CreatedRequest, <%=module%>UpdatedRequest, <%=module%>PageableRequest> {
    private final <%=module%>Service service;
    @SneakyThrows
    @Override
    public ResponseMessage<<%=module%>Response> findOne(String id)
    {
        <%=module%>DTO responseDto = this.service.findOne(id);
        <%=module%>Response response = new <%=module%>Response();
        <%=module%>Mapper.INSTANCE.dtoToResponse(responseDto, response);

        return new ResponseBuilderMessage<<%=module%>Response>()
                .success().addData(response).build();
    }
    @SneakyThrows
    @Override
    public ResponseMessage<PageableResponse<<%=module%>ItemResponse>> findWithPage(<%=module%>PageableRequest request)
    {
        <%=module%>DTO <%=module%>DTO = new <%=module%>DTO();
        <%=module%>Mapper.INSTANCE.pagableToDto(request, <%=module%>DTO);
        Page<<%=module%>DTO> page = this.service.findAll(<%=module%>DTO, request);
        List<<%=module%>ItemResponse> responseList = new ArrayList<>();
        <%=module%>Mapper.INSTANCE.listDtoToListItemResponse(page.getContent(), responseList);
        PageableResponse<<%=module%>ItemResponse> response = new PageableResponse<>(page.getTotalElements(), responseList, request);

        return new ResponseBuilderMessage<PageableResponse<<%=module%>ItemResponse>>()
                .success().addData(response).build();
    }
    @SneakyThrows
    @Override
    public ResponseMessage<<%=module%>Response> create(<%=module%>CreatedRequest request)
    {
        <%=module%>DTO <%=module%>DTO = new <%=module%>DTO();
        <%=module%>Mapper.INSTANCE.createdToDto(request, <%=module%>DTO);
        <%=module%>DTO responseDto = this.service.create(<%=module%>DTO);
        <%=module%>Response response = new <%=module%>Response();
        <%=module%>Mapper.INSTANCE.dtoToResponse(responseDto, response);

        return new ResponseBuilderMessage<<%=module%>Response>()
                .success().addData(response).build();
    }
    @SneakyThrows
    @Override
    public ResponseMessage<<%=module%>Response> update(String id, <%=module%>UpdatedRequest request)
    {
        <%=module%>DTO <%=module%>DTO = new <%=module%>DTO();
        <%=module%>Mapper.INSTANCE.updatedToDto(request, <%=module%>DTO);
        <%=module%>DTO responseDto = this.service.update(id, <%=module%>DTO);
        <%=module%>Response response = new <%=module%>Response();
        <%=module%>Mapper.INSTANCE.dtoToResponse(responseDto, response);
        return new ResponseBuilderMessage<<%=module%>Response>()
                .success().addData(response).build();
    }

    @SneakyThrows
    @Override
    public ResponseMessage<Void> delete(String id)
    {
        this.service.delete(id);
        return new ResponseBuilderMessage<Void>()
                .success().build();
    }

}
